diff --git a/base/server/cms/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java b/base/server/cms/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java
index 8e47298..942e92f 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java
@@ -1177,54 +1300,81 @@ public class CMCOutputTemplate {
         return bpid;
     }
 
+    protected void audit(AuditEvent event) {
+
+        String template = event.getMessage();
+        Object[] params = event.getParameters();
+
+        String message = CMS.getLogMessage(template, params);
+
+        audit(message);
+    }
+
+    protected void audit(String msg) {
+        // in this case, do NOT strip preceding/trailing whitespace
+        // from passed-in String parameters
+
+        if (mSignedAuditLogger == null) {
+            return;
+        }
+
+        mSignedAuditLogger.log(ILogger.EV_SIGNED_AUDIT,
+                null,
+                ILogger.S_SIGNED_AUDIT,
+                ILogger.LL_SECURITY,
+                msg);
+    }
+
     private RevocationReason toRevocationReason(ENUMERATED n) {
         long code = n.getValue();
-        if (code == RevRequest.aACompromise.getValue())
+        if (code == RevokeRequest.aACompromise.getValue())
             return RevocationReason.UNSPECIFIED;
-        else if (code == RevRequest.affiliationChanged.getValue())
+        else if (code == RevokeRequest.affiliationChanged.getValue())
             return RevocationReason.AFFILIATION_CHANGED;
-        else if (code == RevRequest.cACompromise.getValue())
+        else if (code == RevokeRequest.cACompromise.getValue())
             return RevocationReason.CA_COMPROMISE;
-        else if (code == RevRequest.certificateHold.getValue())
+        else if (code == RevokeRequest.certificateHold.getValue())
             return RevocationReason.CERTIFICATE_HOLD;
-        else if (code == RevRequest.cessationOfOperation.getValue())
+        else if (code == RevokeRequest.cessationOfOperation.getValue())
             return RevocationReason.CESSATION_OF_OPERATION;
-        else if (code == RevRequest.keyCompromise.getValue())
+        else if (code == RevokeRequest.keyCompromise.getValue())
             return RevocationReason.KEY_COMPROMISE;
-        else if (code == RevRequest.privilegeWithdrawn.getValue())
+        else if (code == RevokeRequest.privilegeWithdrawn.getValue())
             return RevocationReason.UNSPECIFIED;
-        else if (code == RevRequest.removeFromCRL.getValue())
+        else if (code == RevokeRequest.removeFromCRL.getValue())
             return RevocationReason.REMOVE_FROM_CRL;
-        else if (code == RevRequest.superseded.getValue())
+        else if (code == RevokeRequest.superseded.getValue())
             return RevocationReason.SUPERSEDED;
-        else if (code == RevRequest.unspecified.getValue())
+        else if (code == RevokeRequest.unspecified.getValue())
             return RevocationReason.UNSPECIFIED;
         return RevocationReason.UNSPECIFIED;
     }
 
     private boolean verifyRevRequestSignature(SignedData msgData) {
+        String method = "CMCOutputTemplate: verifyRevRequestSignature: ";
+        CMS.debug(method + "begins");
         try {
             EncapsulatedContentInfo ci = msgData.getContentInfo();
             OCTET_STRING content = ci.getContent();
             ByteArrayInputStream s = new ByteArrayInputStream(content.toByteArray());
             TaggedAttribute tattr = (TaggedAttribute) (new TaggedAttribute.Template()).decode(s);
             SET values = tattr.getValues();
-            RevRequest revRequest = null;
-            if (values != null && values.size() > 0)
-                revRequest =
-                        (RevRequest) (ASN1Util.decode(new RevRequest.Template(),
-                                ASN1Util.encode(values.elementAt(0))));
+            RevokeRequest revRequest = null;
+            if (values != null && values.size() > 0) {
+                revRequest = (RevokeRequest) (ASN1Util.decode(new RevokeRequest.Template(),
+                        ASN1Util.encode(values.elementAt(0))));
+            } else {
+                CMS.debug(method + "attribute null");
+                return false;
+            }
 
             SET dias = msgData.getDigestAlgorithmIdentifiers();
             int numDig = dias.size();
             Hashtable<String, byte[]> digs = new Hashtable<String, byte[]>();
             for (int i = 0; i < numDig; i++) {
-                AlgorithmIdentifier dai =
-                        (AlgorithmIdentifier) dias.elementAt(i);
-                String name =
-                        DigestAlgorithm.fromOID(dai.getOID()).toString();
-                MessageDigest md =
-                        MessageDigest.getInstance(name);
+                AlgorithmIdentifier dai = (AlgorithmIdentifier) dias.elementAt(i);
+                String name = DigestAlgorithm.fromOID(dai.getOID()).toString();
+                MessageDigest md = MessageDigest.getInstance(name);
                 byte[] digest = md.digest(content.toByteArray());
                 digs.put(name, digest);
             }
@@ -1232,8 +1382,7 @@ public class CMCOutputTemplate {
             SET sis = msgData.getSignerInfos();
             int numSis = sis.size();
             for (int i = 0; i < numSis; i++) {
-                org.mozilla.jss.pkix.cms.SignerInfo si =
-                        (org.mozilla.jss.pkix.cms.SignerInfo) sis.elementAt(i);
+                org.mozilla.jss.pkix.cms.SignerInfo si = (org.mozilla.jss.pkix.cms.SignerInfo) sis.elementAt(i);
                 String name = si.getDigestAlgorithm().toString();
                 byte[] digest = digs.get(name);
                 if (digest == null) {
@@ -1244,17 +1393,15 @@ public class CMCOutputTemplate {
                 }
                 SignerIdentifier sid = si.getSignerIdentifier();
                 if (sid.getType().equals(SignerIdentifier.ISSUER_AND_SERIALNUMBER)) {
-                    org.mozilla.jss.pkix.cms.IssuerAndSerialNumber issuerAndSerialNumber =
-                            sid.getIssuerAndSerialNumber();
+                    org.mozilla.jss.pkix.cms.IssuerAndSerialNumber issuerAndSerialNumber = sid
+                            .getIssuerAndSerialNumber();
                     java.security.cert.X509Certificate cert = null;
                     if (msgData.hasCertificates()) {
                         SET certs = msgData.getCertificates();
                         int numCerts = certs.size();
                         for (int j = 0; j < numCerts; j++) {
-                            org.mozilla.jss.pkix.cert.Certificate certJss =
-                                    (Certificate) certs.elementAt(j);
-                            org.mozilla.jss.pkix.cert.CertificateInfo certI =
-                                    certJss.getInfo();
+                            org.mozilla.jss.pkix.cert.Certificate certJss = (Certificate) certs.elementAt(j);
+                            org.mozilla.jss.pkix.cert.CertificateInfo certI = certJss.getInfo();
                             Name issuer = certI.getIssuer();
                             byte[] issuerB = ASN1Util.encode(issuer);
                             INTEGER sn = certI.getSerialNumber();
@@ -1270,11 +1417,33 @@ public class CMCOutputTemplate {
                     }
 
                     if (cert != null) {
+                        CMS.debug(method + "found cert");
                         PublicKey pbKey = cert.getPublicKey();
                         PK11PubKey pubK = PK11PubKey.fromSPKI(((X509Key) pbKey).getKey());
                         si.verify(digest, ci.getContentType(), pubK);
+
+                        // now check validity of the cert
+                        java.security.cert.X509Certificate[] x509Certs = new java.security.cert.X509Certificate[1];
+                        x509Certs[0] = cert;
+                        if (CMS.isRevoked(x509Certs)) {
+                            CMS.debug(method + "CMC signing cert is a revoked certificate");
+                            return false;
+                        }
+                        try {
+                            cert.checkValidity();
+                        } catch (CertificateExpiredException e) {
+                            CMS.debug(method + "CMC signing cert is an expired certificate");
+                            return false;
+                        } catch (Exception e) {
+                            return false;
+                        }
+
                         return true;
+                    } else {
+                        CMS.debug(method + "cert not found");
                     }
+                } else {
+                    CMS.debug(method + "unsupported SignerIdentifier for CMC revocation");
                 }
             }
 
diff --git a/base/server/cms/src/com/netscape/cms/servlet/common/GenPendingTemplateFiller.java b/base/server/cms/src/com/netscape/cms/servlet/common/GenPendingTemplateFiller.java
index 83a2d8c..4578a98 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/common/GenPendingTemplateFiller.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/common/GenPendingTemplateFiller.java
@@ -158,9 +158,9 @@ public class GenPendingTemplateFiller implements ICMSTemplateFiller {
                 byte[] dig;
 
                 try {
-                    MessageDigest SHA1Digest = MessageDigest.getInstance("SHA1");
+                    MessageDigest SHA2Digest = MessageDigest.getInstance("SHA256");
 
-                    dig = SHA1Digest.digest(salt.getBytes());
+                    dig = SHA2Digest.digest(salt.getBytes());
                 } catch (NoSuchAlgorithmException ex) {
                     dig = salt.getBytes();
                 }
@@ -199,16 +199,15 @@ public class GenPendingTemplateFiller implements ICMSTemplateFiller {
                     SignerIdentifier si = new
                             SignerIdentifier(SignerIdentifier.ISSUER_AND_SERIALNUMBER, ias, null);
 
-                    // SHA1 is the default digest Alg for now.
                     DigestAlgorithm digestAlg = null;
                     SignatureAlgorithm signAlg = null;
                     org.mozilla.jss.crypto.PrivateKey privKey = CryptoManager.getInstance().findPrivKeyByCert(x509cert);
                     org.mozilla.jss.crypto.PrivateKey.Type keyType = privKey.getType();
 
                     if (keyType.equals(org.mozilla.jss.crypto.PrivateKey.RSA)) {
-                        signAlg = SignatureAlgorithm.RSASignatureWithSHA1Digest;
-                    } else if (keyType.equals(org.mozilla.jss.crypto.PrivateKey.DSA)) {
-                        signAlg = SignatureAlgorithm.DSASignatureWithSHA1Digest;
+                        signAlg = SignatureAlgorithm.RSASignatureWithSHA256Digest;
+                    } else if (keyType.equals(org.mozilla.jss.crypto.PrivateKey.EC)) {
+                        signAlg = SignatureAlgorithm.ECSignatureWithSHA256Digest;
                     } else {
                         CMS.debug("GenPendingTemplateFiller::getTemplateParams() - "
                                  + "keyType " + keyType.toString()
@@ -220,8 +219,8 @@ public class GenPendingTemplateFiller implements ICMSTemplateFiller {
                     byte[] digest = null;
 
                     try {
-                        SHADigest = MessageDigest.getInstance("SHA1");
-                        digestAlg = DigestAlgorithm.SHA1;
+                        SHADigest = MessageDigest.getInstance("SHA256");
+                        digestAlg = DigestAlgorithm.SHA256;
 
                         ByteArrayOutputStream ostream = new ByteArrayOutputStream();
 
diff --git a/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java b/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
index 93039a4..330b5ff 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
@@ -413,7 +413,7 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
         }
 
         setInputsIntoContext(request, profile, ctx);
-        CMS.debug("ProfileSubmistServlet: set Inputs into Context");
+        CMS.debug("ProfileSubmitCMCServlet: set Inputs into Context");
 
         // before creating the request, authenticate the request
 
@@ -560,9 +560,14 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
         // In case of decryptedPOP, request already exists, find it and
         // put in provedReq.
         IRequest provedReq = null;
+        boolean isRevoke = false;
         if (reqs == null) {
             // handling DecryptedPOP request here
             Integer reqID = (Integer) context.get("cmcDecryptedPopReqId");
+            if (reqID == null) {
+                CMS.debug("ProfileSubmitCMCServlet: revocation request");
+                isRevoke = true;
+            } else {
             provedReq = profile.getRequestQueue().findRequest(new RequestId(reqID.toString()));
             if (provedReq == null) {
 
@@ -584,6 +589,7 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
             } else {
                 CMS.debug("ProfileSubmitCMCServlet: provedReq not null");
             }
+            }
         }
 
         String errorCode = null;
@@ -592,7 +598,7 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
         ///////////////////////////////////////////////
         // populate request
         ///////////////////////////////////////////////
-        for (int k = 0; (provedReq == null) &&(k < reqs.length); k++) {
+        for (int k = 0; (!isRevoke) && (provedReq == null) &&(k < reqs.length); k++) {
             // adding parameters to request
             setInputsIntoRequest(request, profile, reqs[k]);
 
@@ -712,7 +718,7 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
             if (reqs != null && reqs.length > 0)
                 error_codes = new int[reqs.length];
 
-            for (int k = 0; (provedReq == null) && (k < reqs.length); k++) {
+            for (int k = 0; (!isRevoke) && (provedReq == null) && (k < reqs.length); k++) {
                 try {
                     // reset the "auditRequesterID"
                     auditRequesterID = auditRequesterID(reqs[k]);
diff --git a/base/server/cmscore/src/com/netscape/cmscore/apps/CMSEngine.java b/base/server/cmscore/src/com/netscape/cmscore/apps/CMSEngine.java
index 94a0783..b111f71 100644
--- a/base/server/cmscore/src/com/netscape/cmscore/apps/CMSEngine.java
+++ b/base/server/cmscore/src/com/netscape/cmscore/apps/CMSEngine.java
@@ -62,6 +62,7 @@ import org.mozilla.jss.util.PasswordCallback;
 import org.w3c.dom.Element;
 import org.w3c.dom.NodeList;
 
+import com.netscape.certsrv.authentication.ISharedToken;
 import com.netscape.certsrv.acls.ACL;
 import com.netscape.certsrv.acls.ACLEntry;
 import com.netscape.certsrv.acls.EACLsException;
@@ -1912,6 +1913,38 @@ public class CMSEngine implements ICMSEngine {
         }
     }
 
+    public ISharedToken getSharedTokenClass(String configName) {
+        String method = "CMSEngine: getSharedTokenClass: ";
+        ISharedToken tokenClass = null;
+
+        String name = null;
+        try {
+            CMS.debug(method + "getting :" + configName);
+            name = CMS.getConfigStore().getString(configName);
+            CMS.debug(method + "Shared Secret plugin class name retrieved:" +
+                    name);
+        } catch (Exception e) {
+            CMS.debug(method + " Failed to retrieve shared secret plugin class name");
+            return null;
+        }
+
+        try {
+            tokenClass = (ISharedToken) Class.forName(name).newInstance();
+            CMS.debug(method + "Shared Secret plugin class retrieved");
+        } catch (ClassNotFoundException e) {
+            CMS.debug(method + " Failed to find class name: " + name);
+            return null;
+        } catch (InstantiationException e) {
+            CMS.debug("EnrollProfile: Failed to instantiate class: " + name);
+            return null;
+        } catch (IllegalAccessException e) {
+            CMS.debug(method + " Illegal access: " + name);
+            return null;
+        }
+
+        return tokenClass;
+    }
+
     public ILogger getLogger() {
         return Logger.getLogger();
     }
diff --git a/base/server/test/com/netscape/cmscore/app/CMSEngineDefaultStub.java b/base/server/test/com/netscape/cmscore/app/CMSEngineDefaultStub.java
index dd28adb..b314dac 100644
--- a/base/server/test/com/netscape/cmscore/app/CMSEngineDefaultStub.java
+++ b/base/server/test/com/netscape/cmscore/app/CMSEngineDefaultStub.java
@@ -23,6 +23,7 @@ import com.netscape.certsrv.acls.EACLsException;
 import com.netscape.certsrv.acls.IACL;
 import com.netscape.certsrv.apps.ICMSEngine;
 import com.netscape.certsrv.apps.ICommandQueue;
+import com.netscape.certsrv.authentication.ISharedToken;
 import com.netscape.certsrv.authority.IAuthority;
 import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.base.IArgBlock;
@@ -370,6 +371,10 @@ public class CMSEngineDefaultStub implements ICMSEngine {
         return null;
     }
 
+    public ISharedToken getSharedTokenClass(String configName) {
+        return null;
+    }
+
     public void putPasswordCache(String tag, String pw) {
     }
 
diff --git a/base/util/src/com/netscape/cmsutil/util/Utils.java b/base/util/src/com/netscape/cmsutil/util/Utils.java
index 98becdc..933432d 100644
--- a/base/util/src/com/netscape/cmsutil/util/Utils.java
+++ b/base/util/src/com/netscape/cmsutil/util/Utils.java
@@ -285,6 +285,11 @@ public class Utils {
         return string;
     }
 
+    public static String base64encodeSingleLine(byte[] bytes) {
+        String string = new Base64().encodeToString(bytes);
+        return string;
+    }
+ 
     public static byte[] base64decode(String string) {
         byte[] bytes = Base64.decodeBase64(string);
         return bytes;
-- 
2.7.4

